M=zeros(100);
for h=1:100
    for k=1:100
        M(h,k)=(h-50)^2+(k-50)^2;
    end
end

%altro modo
%[H,K]=meshgrid(1:100);
%M=(H-50).^2+(K-50).^2;

[h,k]=find(M>20 & M<50);
num=length(h);

M1=M(40:60,40:60);
M2=M1;
medi_righe=mean(M2,2);
for ind_=1:size(M1,1)
    M2(ind_,:)=M2(ind_,:)-medi_righe(ind_);
end
%altro modo
%medi_rep=repmat(medi_righe,1,100);
%M2=M2-medi_rep;

g_map=colormap('gray');
mia_map=g_map(1:32,:);
M2=(M2-min(M2(:)))/(max(M2(:))-min(M2(:)))*31+1;

M3=M1;
temp=M3<0.9*max(M3(:)); %gli elementi di temp uguali a uno sono
%solo quelli corrispondenti a quelli di M3 minori del 90% del massimo
M3=(1-temp).*M3;%si annullano gli elementi minori al 90% del max

M4=M1;
temp=M4>0.9*max(M4(:)); %gli elementi di temp uguali a uno sono
%solo quelli corrispondenti a quelli di M3 maggiori del 90% del massimo
M4=(1-temp).*M4;


Imm_RGB=zeros([size(M4) 3]);

%scalo i valori di M3 e M4 affinch il massimo sia uguale a 1.
%il valore minimo  gi zero. 
%visto che i massimi in M3 e M4 sono differenti, potrei avere diverse
%scelte possibili

%scelgo di scalare rispetto al massimo di M4, che  quello maggiore
M3=M3/max(M4(:));
M4=M4/max(M4(:));

Imm_RGB(:,:,1)=M3;
Imm_RGB(:,:,2)=M4;
Imm_RGB(:,:,3)=M4;


imwrite(Imm_RGB,'Immagine2.tif','tif')
