%la frequenza max  10.25 Hz, la freq. di Nyquist  20.5 Hz
T=0.6;
f_ny=20.5;
fc=2*f_ny;
dt=1/fc;

t=0:dt:T;
s=2*cos(20.1*pi*t+pi/5)+4*cos(20.5*pi*t+pi/6);

df1=0.1;
T1=1/df1;
N1=T1/dt;%in questo caso N1  intero
S=fft(s,N1);

f=df*[-(N1-1)/2:(N1-1)/2];

figure
stem(f,abs(fftshift(S)))
figure
stem(f,angle(fftshift(S)))

df2=10.25-10.05;
T=1/df2;
N2=T/dt;%in questo caso N2  intero
t=0:dt:(N2-1)*dt;
s=2*cos(20.1*pi*t+pi/5)+4*cos(20.5*pi*t+pi/6);
S=fft(s);
f=df*[-(N2-1)/2:(N2-1)/2];
figure
stem(f,abs(fftshift(S)))
figure
stem(f,angle(fftshift(S)))



%si nota che facendo ora uno zero padding ad esempio N=500;
S=fft(s,500);
df=1/(500*dt);
f=df*[-250:249];
figure
stem(f,abs(fftshift(S)))
figure
stem(f,angle(fftshift(S)))
%ingrandendo  possibile evidenziare i due picchi
%applicando lo stesso zero padding al caso precedente
%non sarebbe successo






