T0=0.2;
T=1;
dt=0.05;

t=0:dt:T;%nb strano comportamento della funzione square per t=0:dt:T-dt;

s=0.5*square(2*pi/T0*t)+0.5;
figure
plot(t,s)

% un filtro FIR con 7 coeff

imp=[1 zeros(1,6)];

B=[1 2 3 4 3 2 1];%visto che  un FIR h =B/A
A=16;
h=filter(B,A,imp);
figure
stem(h);

df=1/(dt*length(h));
N=7;
f=df*[-(N-1)/2:(N-1)/2];
H=fft(h);
figure
stem(f,abs(fftshift(H)));
figure
stem(f,angle(fftshift(H)));

y1=conv(h,s);

H=fft(h,length(h)+length(s)-1);
S=fft(s,length(h)+length(s)-1);
Y2=H.*S;
y2=ifft(Y2);
t=0:dt:length(y1)*dt-dt;
figure
plot(t,y1)
hold on
plot(t,y2,'r-^')

x=zeros(1,6);
x(1)=1; %delta[n] 
x(6)=-1; %-delta[n-5] 

t=0:dt:(6+7-1)*dt-dt;
y3=conv(h,x);

figure
stem(t,y3);

h_all_pass=zeros(1,7);
h_all_pass(4)=1;
h_hp=h_all_pass-h;

figure
freqz(h_hp,1) %sempre filtro fir


